/*
 * Dummy.java
 *
 * Created on October 30, 2002, 2:35 PM
 */

/**
 *
 * @author  Mauro Caporuscio_2
 */
import CoMETA.*;
import siena.*;
import java.util.Vector;

class MessageCatcher implements Notifiable{
    
    ConnectedClient client;
    
    public MessageCatcher(ConnectedClient c){
       client = c;
    }
    public void notify(Notification n) throws SienaException {
        if(!client.isMoving()) return;
        
        client.getPersistentNotifications().addNotification((Notification) n);
        System.out.print("I just got this event for " +client.getID() +": ");
        System.out.println(n.toString());
    }
    
    public void notify(Notification[] s) throws SienaException {
    }
}

public class Dummy implements DummyInterface {
    
    ConnectedClient client = null;
    String SienaServerURL = null;
    ThinClient consumer = null;
    //String sienaURL = null;
    Vector subList = null;
    MessageCatcher messageCatcher = null;
    PingCatch pingCatch = null;

    public Dummy(ThinClient SServer, ConnectedClient c, Vector filterList) throws Exception{
      
      client = c;
      try {
            consumer = SServer;
            
            if (filterList != null)
               {
               subList = new Vector();
               messageCatcher = new MessageCatcher(client);
               
               for(int i=0; i<filterList.size(); i++)
                   {
                     Filter filter = (Filter) filterList.get(i);
                     
                     consumer.subscribe(filter, messageCatcher);
                     subList.addElement(filter);
                   }
               }
          }
      catch(Exception ex) 
          {
	    ex.printStackTrace();
	    throw ex;
	  } 
    }
    
    public void close(){
       try{
            consumer.unsubscribe(messageCatcher);
            if (pingCatch != null) pingCatch.close();
          }  
      catch(Exception ex) 
          {
	    ex.printStackTrace();
	    System.exit(1);
	  }   
    }
}
