/*
 * ProxyImpl.java
 *
 * Created on August 8, 2002, 3:21 PM
 */

/**
 *
 * @author  Mauro Caporuscio
 */
//package provaCoMETA;

import CoMETA.*;
import java.util.*;

import siena.*;

public class ProxyToServiceImpl implements ProxyToServiceInterface{
    
    Hashtable ClientList = null;
    ProxyToProxy RemoteProxy = null;
    String ProxyName, SienaServerName;
    ThinClient SienaConnection = null;
     
    /** Creates a new instance of ProxyImpl */
    public ProxyToServiceImpl(){
        
    }
    
    public void initialize(String service_name, Hashtable clientList){

        try{
            SienaServerName = service_name;
            SienaConnection = new ThinClient(SienaServerName);
            ClientList = clientList;
        }catch(Exception ex){
            ex.printStackTrace();
            System.exit(1);
        }
    }    
    
    public boolean createQueue(String Client_id, Vector filterList){
        ConnectedClient c;
        DummyInterface dummy = null;
        //is Client_id on client's list?
        if (ClientList.get((String) Client_id) == null) 
              //It's a new client
              c = new ConnectedClient(Client_id);
        else{
              //Client_id already exists
              c = (ConnectedClient) ClientList.get((String) Client_id);
              if (c.isMoving()) return false;
            }
        //Client status is "movingON"
        c.movingON();
             
        try{
              //Creates a new Client for storing Notifications
              //dummy = new Dummy(SienaServerName, c, filterList);
              dummy = new Dummy(SienaConnection, c, filterList);  
           }
        catch(Exception ex){
              return false;
           }  
        c.setServiceDummy(dummy);
        //Updates List of clients
        ClientList.put((String) Client_id, (ConnectedClient) c);
        
        return true;
    }
    
    
    public boolean subscribeAckRequest(ConnectedClient c) {
      
      //Create subscription for ACK_REQUEST
      try{
           Filter filter = new Filter();
           filter.addConstraint("__TYPE__","__ACK_REQUEST__");
           filter.addConstraint("__CLIENT_ID__",c.getID());
           
           ((Dummy) c.getServiceDummy()).pingCatch = new PingCatch(c.getID(), SienaServerName, filter);
           
           System.out.println("waiting for "+ filter.toString());
           return true;
         }
      catch(Exception e)
         {
           e.printStackTrace();
           return false;
         }
    }
    
    
    public boolean move_out_ping(ConnectedClient c) {
        
        c.MoveOutAck = false;
        
        Filter filter = new Filter();
        filter.addConstraint("__TYPE__","__MOVEOUT_ACK_REQUEST__");
        filter.addConstraint("__CLIENT_ID__", c.getID());
        Notifiable action = new MoveOutAckCatch(c);
           
        Notification notif = new Notification();
        notif.putAttribute("__TYPE__", "__MOVEOUT_ACK_REQUEST__");
        notif.putAttribute("__CLIENT_ID__", c.getID());
        
        try{
             SienaConnection.subscribe(filter, action);
             System.out.println("waiting for "+ filter.toString());
             SienaConnection.publish(notif);
             System.out.println("published "+ notif.toString());
                          
             int inc = 0;
             while(!c.MoveOutAck && !(inc>100)) 
                  {
                    Thread.sleep(1000);
                    inc++;
                  }
                 
             SienaConnection.unsubscribe(action);
             return true;
            }
        catch(Exception ex){
             ex.printStackTrace();
             return false;
           }
    }            
}

