package CoMETA;

/*
 * Proxy.java
 *
 * Created on August 8, 2002, 2:12 PM
 */

/**
 *
 * @author  Mauro Caporuscio
 */
import java.util.*;

public class ProxyToClient{
    
    private Hashtable ClientList = null;
    private ProxyToServiceInterface proxy = null;
    
    public ProxyToClient(ProxyToServiceInterface p, Hashtable cList){
        ClientList = cList;
        proxy = p;
    }
    
    boolean moveOut(String Client_id, Vector filterList, boolean QoS, boolean ping, long delay){
        
        if (!proxy.createQueue(Client_id, filterList)) return false;
        ConnectedClient c = (ConnectedClient) ClientList.get((String) Client_id);
        
        if(ping) 
            if (!proxy.move_out_ping(c)) 
                return false;
            
        try{ 
            Thread.sleep(delay);
        }catch(Exception ex){
            ex.printStackTrace();
        }
            
        if(QoS) 
            if (!proxy.subscribeAckRequest(c))
                return false;
        
        System.out.println("moveOut() remotely called by "+Client_id);
        return true;
    }
 
    public Vector moveIn(String Client_id){
        System.out.println("moveIn() remotely called by "+Client_id);
        ConnectedClient c = (ConnectedClient) ClientList.get((String) Client_id);
        
        if (c == null) 
           {
              proxy.createQueue(Client_id, null);
              return null;
           }   
        else
           {
              if (!c.isMoving()) return null; 
              
              c.movingOFF();
              Vector v = c.getPersistentNotifications().getStoredNotifications();
              c.getServiceDummy().close();
              c.setServiceDummy(null);
              ClientList.put((String) Client_id, (ConnectedClient) c);
              return v;
           }
    }
    
    Vector downloadEvents(String Client_id, String from){
        //download events from the old Proxy 
        Vector remote_events = null;
    
        try{
             Sender sender = new Sender(from);
             remote_events = sender.send_getEvents_req(Client_id);
             sender.send_removeClient_req(Client_id);
           }
        catch(Exception e){
           System.out.println(e.getMessage());
           e.printStackTrace();
        }
        
        System.out.println("downloadEvents() remotely called by "+Client_id);
        return remote_events;
    }
}
