#! /bin/sh
#
JAVA=/usr/java/j2sdk1.4.0/bin/java
pwd=`pwd`
#
#server1=moose.cs.colorado.edu
#server2=rocky.cs.colorado.edu
server1=128.138.242.72
server2=128.138.242.76
server3=pshe.cs.colorado.edu
#
#proxy1=moose.cs.colorado.edu:5555
#proxy2=rocky.cs.colorado.edu:5555
proxy1=128.138.242.72:5555
proxy2=128.138.242.76:5555
#
#Configuration Parameters
#


moDelay=0
miDelay=0
pdelays=300000
subs=100
latency=3600
pubs=5000
#
jar=CoMETA.jar:siena-1.4.3b8.jar:.
#
consumer=CoMETA_Stabilize_Consumer
producer=CoMETA_Stabilize_Producer
#
port=12345
#
trap test_interrupted 1 2 13 15
test_interrupted () {
    echo "TEST INTERRUPTED" 
    kill $ppid $cpid
    exit 1
}
#

CONSUMER="$JAVA -classpath $jar $consumer $server1:$port $proxy1 $server2:$port $proxy2"
#
PRODUCER="$JAVA -classpath $jar $producer $server3:$port"
#
fname () {
    echo "$1_$2_$3_s$4_p$5"
}
#
#
for q in "0 0" "1 1"
  do
  f=`fname $q $moDelay $miDelay $subs $pdelays`
  test -f "../longRes/${f}" && continue
  echo starting "${f}"
  $CONSUMER $q $moDelay $miDelay $subs $latency "../longRes/${f}" &
  cpid=$!
  sleep 10
  $PRODUCER $pubs $subs $pdelays &
  ppid=$!
  wait $cpid
  kill $ppid
  wait $ppid
done