#! /bin/sh
#
JAVA=/usr/java/j2sdk1.4.0/bin/java
pwd=`pwd`
#
#server1=moose.cs.colorado.edu
#server2=rocky.cs.colorado.edu
server1=128.138.242.72
server2=128.138.242.76
server3=pshe.cs.colorado.edu
#
#proxy1=moose.cs.colorado.edu:5555
#proxy2=rocky.cs.colorado.edu:5555
proxy1=128.138.242.72:5555
proxy2=128.138.242.76:5555
#
#Configuration Parameters
#
runs='1 2'
qos='0 1'
mop='0 1'
moDelay='0 200'
miDelay='0 200'
pdelays='1000 500 200 100'
subs='10 50 100'
latency=30
pubs=5000
#
jar=CoMETA.jar:siena-1.4.3b8.jar:.
#
consumer=CoMETA_Stabilize_Consumer
producer=CoMETA_Stabilize_Producer
#
port=12345
#
trap test_interrupted 1 2 13 15
test_interrupted () {
    echo "TEST INTERRUPTED" 
    kill $ppid $cpid
    exit 1
}
#

CONSUMER="$JAVA -classpath $jar $consumer $server1:$port $proxy1 $server2:$port $proxy2"
#
PRODUCER="$JAVA -classpath $jar $producer $server3:$port"
#
fname () {
    echo "$1_$2_$3_$4_s$5_p$6"
}
#
#
for pr in $pdelays
  do
  for s in $subs
    do
    for m in $mop
      do
      for q in $qos
	do
	for od in $moDelay
	  do
	  for id in $miDelay
	    do    
	    f=`fname $m $q $od $id $s $pr`
	    for r in $runs
	      do
	      test -f "../seawindRes/${f}_r$r" && continue
              echo starting "${f}_r$r"
	      $CONSUMER $m $q $od $id $s $latency "../seawindRes/${f}_r$r" &
	      cpid=$!
	      sleep 10
	      $PRODUCER $pubs $s $pr &
	      ppid=$!
	      wait $cpid
	      kill $ppid
	      wait $ppid
	    done
	  done
	done
      done
    done
  done
done